import java.awt.*;
import java.applet.Applet;
import java.net.*;

public class AppletImageLoader implements ImageLoader{
	private Applet applet;
	private URL loadBase;
	
	public AppletImageLoader(Applet applet, URL loadBase){
		this.applet = applet;
		this.loadBase = loadBase;
	}
	
	public Image loadImage(String imageName){
		Image image = null;
		
		// MediaTracker쐬
		MediaTracker tracker = new MediaTracker(applet);
		
		// C[W擾
		image = applet.getImage(loadBase, imageName);
		
		// MediaTrackerɊĎC[Wǉ
		tracker.addImage(image, 0);
		
		try{
			// C[W[ĥҋ@
			tracker.waitForID(0);
		}catch(InterruptedException e){
		}
		
		return image;
	}
}