import java.awt.*;
import java.awt.image.*;

/**
 * ~\NX.
 */
public class Circle implements Runnable, InternalObject, ActiveObject{
	private int maxDiameter = 200; // ̉~̍ő̒a
	private int currentDiameter = 1; // ̉~݂̌̒a
	private int x = 0; // ̉~̃AvbgłxW
	private int y = 0; // ̉~̃AvbgłyW
	private BufferedImage image; // ̉~̕`C[W
	private Graphics2D graphics; // ̉~̕`C[W̃OtBbNXReLXg
	
	// ~`悷̂ɎgpFRGBl
	private int rgb[] = {100, 100, 100};
	private int rgbIndex = 0;
	
	private Thread thread;
	
	private InternalObjectContainer parent; // Avbg
	
	/**
	 * ~쐬.
	 *
	 * @param parent ̉~܂ރAvbg
	 */
	public Circle(InternalObjectContainer parent){
		this.parent = parent;
		x = parent.getWidth() / 2 - maxDiameter / 2;
		y = x;
	}
	
	/**
	 * ~̕`揈Jn.
	 */
	public void activate(){
		thread = new Thread(this);
		thread.start();
	}
	
	/**
	 * ~̕`揈s.
	 */
	public void run(){
		while(true){
			currentDiameter++;
			
			if(currentDiameter >= maxDiameter){
				currentDiameter = 1;
			}
			
			try{
				Thread.sleep(100);
			}catch(InterruptedException e){
			}
		}
	}
	
	/**
	 * ~̍xWԂ.
	 *
	 * @return ~̍xW
	 */
	public int getX(){
		return x;
	}
	
	/**
	 * ~̍yWԂ.
	 *
	 * @return ~̍yW
	 */
	public int getY(){
		return y;
	}
	
	/**
	 * ~̈ʒuݒ肷.
	 *
	 * @param x ~̍xW
	 * @param y ~̍yW
	 */
	public void setLocation(int x, int y){
		this.x = x;
		this.y = y;
	}
	
	/**
	 * ~̕Ԃ.
	 *
	 * @return ~̕
	 */
	public int getWidth(){
		return maxDiameter;
	}
	
	/**
	 * ~̍Ԃ.
	 *
	 * @return ~̍
	 */
	public int getHeight(){
		return maxDiameter;
	}
	
	/**
	 * ~̕`C[WԂ.
	 *
	 * @return ~̕`C[W
	 */
	public Image getImage(){
		if(image == null){
			image = new BufferedImage(
				maxDiameter, maxDiameter, BufferedImage.TYPE_INT_ARGB
			);
			graphics = image.createGraphics();
			
			graphics.setColor(new Color(0, 0, 0, 0));
			graphics.fillRect(0, 0, maxDiameter, maxDiameter);
		}
		
		graphics.setColor(new Color(rgb[0], rgb[1], rgb[2]));
		
		graphics.drawOval(
			maxDiameter / 2 - currentDiameter / 2,
			maxDiameter / 2 - currentDiameter / 2,
			currentDiameter,
			currentDiameter
		);
		
		if(rgb[rgbIndex] < 255){
			rgb[rgbIndex]++;
		}else{
			int prevIndex = rgbIndex - 1;
			
			if(prevIndex < 0){
				prevIndex = 2;
			}
			
			if(rgb[prevIndex] > 100){
				rgb[prevIndex]--;
			}else{
				rgbIndex++;
				
				if(rgbIndex > 2){
					rgbIndex = 0;
				}
			}
		}
		
		return image;
	}
}