import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;

/**
 * ~`Avbg.
 *
 * @version 0.4, 2004/09/03
 * @author  Otaki Shinya
 */
public class En extends Applet implements Runnable, InternalObjectContainer{
	private Thread animationThread;
	private Image offScreenImage;
	private Graphics offScreenGraphics;
	
	// AvbgɊ܂܂IuWFNg
	private Vector internalObjects = new Vector();
	
	// Avbg̔wiF
	private Color bgColors[] = {Color.green, Color.blue, Color.red, Color.orange};
	private int bgColorIndex = 0;
	
	/**
	 * Avbg.
	 */
	public void init(){
		// _uobt@OɎgpItXN[`C[W쐬
		offScreenImage = createImage(getWidth(), getHeight());
		
		// ItXN[C[Wɕ`悷邽߂̃OtBbNXReLXg쐬
		offScreenGraphics = offScreenImage.getGraphics();
		
		// ~쐬ÃAvbgɒǉ
		Circle c = new Circle(this);
		add(c);
		
		// ImageLoader쐬
		final ImageLoader imageLoader = new AppletImageLoader(this, getCodeBase());
		
		// ͂쐬ÃAvbgɒǉ
		Submarine submarine = new Submarine(this, imageLoader, this);
		submarine.setLocation(50, 50);
		add(submarine);
		
		// AvbgŃ}EXNbNꂽƂ̏
		addMouseListener(
			new MouseAdapter(){
				public void mousePressed(MouseEvent e){
					// wiFύX
					changeBgColor();
					
					// ͂ǉ
					Submarine sub = new Submarine(En.this, imageLoader, En.this);
					int x = e.getX() - sub.getWidth() / 2;
					int y = e.getY() - sub.getHeight() / 2;
					sub.setLocation(x, y);
					add(sub);
				}
			}
		);
	}
	
	/**
	 * AvbgJn.
	 */
	public void start(){
		if(animationThread == null){
			animationThread = new Thread(this);
			animationThread.start();
		}
	}
	
	/**
	 * Avbg̃IuWFNg̕`揈s.
	 */
	public void run(){
		while(true){
			repaint();
			
			try{
				Thread.sleep(50);
			}catch(InterruptedException e){
			}
		}
	}
	
	/**
	 * Avbg̍XVs.
	 */
	public void update(Graphics g){
		paint(g);
	}
	
	/**
	 * Avbg̕`s.
	 *
	 * @param g `ɎgpOtBbNXReLXg
	 */
	public void paint(Graphics g){
		// ItXN[C[WNA
		offScreenGraphics.setColor(getBackground());
		offScreenGraphics.fillRect(0, 0, getWidth(), getHeight());
		
		// AvbgɊ܂܂IuWFNg̔q擾
		Iterator iterator = internalObjects.iterator();
		
		while(iterator.hasNext()){
			InternalObject obj = (InternalObject)iterator.next();
			
			// AvbgɊ܂܂IuWFNgItXN[C[Wɕ`悷
			offScreenGraphics.drawImage(
				obj.getImage(), obj.getX(), obj.getY(), this
			);
		}
		
		// ItXN[C[WAvbgɕ`悷
		g.drawImage(offScreenImage, 0, 0, this);
	}
	
	/**
	 * Avbǧ݂̔wiFԂ.
	 *
	 * @return Avbǧ݂̔wiF
	 */
	public Color getBackground(){
		return bgColors[bgColorIndex];
	}
	
	/**
	 * Avbg̔wiFύX.
	 */
	private void changeBgColor(){
		bgColorIndex++;
		
		if(bgColorIndex >= bgColors.length){
			bgColorIndex = 0;
		}
		
		repaint();
	}
	
	/**
	 * AvbgɃIuWFNgǉ.
	 *
	 * @param obj ǉIuWFNg
	 */
	public void add(InternalObject obj){
		internalObjects.addElement(obj);
		
		if(obj instanceof ActiveObject){
			((ActiveObject)obj).activate();
		}
	}
}
